# Copyright 2008, Tomasz Marek
#------------------------------------------------------------------------
# I INVITE you to a while of reflection about a role of LOVE in our lives
# while using this tool, beacuse your brain will be quite idle durnig
# the process :) I kindly suggest you to spend saved time with ones
# that you love! :)
#------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :			frontface.rb 1.1
# Description :		Hower over a back face to reverse it
# Authors :			Tomasz Marek
# Usage :			1. Active the Tool from the icon or Plugins menu
#					2. Hover over a back-face to reverse it.
# Date :			12th October 2008
# Type :			Tool
# History:			1.1 (12.Oct.2008) - correct recognition of back faces
#										in nested components and groups
#					1.0 (11.Oct.2008) - first version

require 'sketchup.rb'

class FrontFaceTool

def initialize
	$ip = Sketchup::InputPoint.new
end

def reset
	$ip.clear
	Sketchup::set_status_text "Hover over a back face to reverse it"
end

def activate
	self.reset
end

def onMouseMove(flags, x, y, view)
	$ip.pick(view,x,y)
	face = $ip.face
	if face!=nil
		camera=view.camera
		ray=view.pickray x,y
		orient=examineFace(face,camera,ray)
		reverseFace(face,view) if orient==false
	end
end

def examineFace(face, camera, ray)
	model=Sketchup.active_model
	item=model.raytest ray
	if item!=nil
		parents=item[1]
		if parents!=nil
			if parents.last==face
				trans=findGlobalTransformation(parents)
				norm=face.normal
				norm.transform! trans
			else
				norm=camera.direction.reverse
			end
		else
			norm=face.normal
		end
	end
	norm=camera.direction.reverse if norm==nil
	angle=camera.direction.angle_between norm
	angle>3.14159265/2.0
end

def findGlobalTransformation(parents)
	trans=Geom::Transformation.new
	parents.each do |parent|
		trans=trans*parent.transformation if parent.class!=Sketchup::Face
	end
	return trans
end

def reverseFace(face,view)
	face.reverse!
	face.material, face.back_material = face.back_material, face.material
	view.invalidate
end

end # of FrontFace class


