require "sketchup.rb"

module Selector

def self.start
@dlg = UI::WebDialog.new("Selector", true, "Selector", 100, 100, 200, 200, true)

@dlg.set_file File.join(File.dirname(__FILE__), "selector.html")

def self.result_text(d, txt)
scr="document.getElementById('results').innerHTML='#{txt}'"
d.execute_script(scr)
end

@dlg.add_action_callback("clear_all") do |d, a|
Sketchup.active_model.selection.clear
end

@dlg.add_action_callback("sel") { |d, p|
val = d.get_element_value "entity_type"
@ss = Sketchup.active_model.active_entities.find_all {|e| e.typename == val }
Sketchup.active_model.selection.add @ss
result_text(d, "Found #{@ss.length} #{val}(s)")
}
@dlg.add_action_callback("clr") {|d, p|
Sketchup.active_model.selection.clear
result_text(d, "")
}
@dlg.add_action_callback("zoom") {|d, p|
Sketchup.active_model.active_view.zoom @ss
}
@dlg.add_action_callback("zoome") {|d, p|
Sketchup.active_model.active_view.zoom_extents
}

@dlg.add_action_callback("hide") {|d, a|
Sketchup.active_model.start_operation "Hide Selected"
Sketchup.active_model.selection.each {|s|
if s.respond_to?("hidden=")
s.hidden=true
end
}
Sketchup.active_model.commit_operation
}
@dlg.add_action_callback("undo") {|d, a| Sketchup.undo }
#Sketchup.active_model.start_operation "Erase"

@dlg.add_action_callback("erase") {|d, a|
Sketchup.active_model.selection.each {|s|
s.erase!
}
Sketchup.active_model.commit_operation
}
@dlg.add_action_callback("toggle") { |d, a|
#puts "toggle:"
#puts a
type, op = a.split(",")
#type.capitalize!
s = Sketchup.active_model.selection
#s.clear

set = Sketchup.active_model.active_entities.find_all {|e| e.typename == type}

status = 0
if op == "true"
status = s.add(set)
else
status = s.remove(set)
end
result_text(d, "#{s.count} enties.")
}

@dlg.show {}
end # def start

end # module Selector
unless( file_loaded?("selector.rb") )
UI.menu.add_item("Selector"){ Selector.start }
file_loaded "selector.rb"
end
