require'4dHans_ToolsInDialog/scripts/makefaces'
require'4dHans_ToolsInDialog/scripts/selection_memory.rb'
require'4dHans_ToolsInDialog/scripts/weld.rb'
require'4dHans_ToolsInDialog/scripts/frontface.rb'
require'4dHans_ToolsInDialog/scripts/deletecoplanaredges.rb'
require'4dHans_ToolsInDialog/scripts/PurgeAll.rb'
require'4dHans_ToolsInDialog/scripts/selector.rb'
require'4dHans_ToolsInDialog/scripts/rectangle.rb'
require'4dHans_ToolsInDialog/scripts/rp_superellipsoid_v10'
require'4dHans_ToolsInDialog/scripts/rp_torus_v10.rb'
require'4dHans_ToolsInDialog/scripts/align_tool'
#require'4dHans_ToolsInDialog/scripts/point'
model = Sketchup.active_model
entities = model.entities
selection = model.selection



def centerSelection
  ss = Sketchup.active_model.selection
  bb = Geom::BoundingBox.new
  if ss.length > 0
    ss.each {|s| bb.add s.bounds }
  else
    bb = Sketchup.active_model.bounds
  end
  center = bb.center
  camera = Sketchup.active_model.active_view.camera
  vec = camera.target - center
  eye = camera.eye
  target = camera.target - vec
  camera.set eye, target, [0, 0, 1]
end

class RemMats 

  def parse_ent(ent)  
    if ent.is_a? Sketchup::ComponentInstance then 
        ent.definition.entities.each {|ede| parse_ent(ede) } 
    elsif (ent.is_a? Sketchup::Group) then ent.entities.each {|ege| parse_ent(ege) }   
    end ; # if 
    ent.material      = nil if ent.respond_to?(:material) ;
    ent.back_material = nil if ent.respond_to?(:back_material) ; 
  end  # def parse_ent 

  def remove() ; 
    Sketchup.active_model.selection.each {|e| parse_ent(e) ; } 
  end ;  # def remove() 
end ;    # class RemMats

def remove_Materials_Smustard

  if Sketchup.active_model.selection.empty? then 
    UI.messagebox("Select Objects Before Running \'Remove All Materials\'.\n\n" +
                  "Use this script to remove all assigned materials\n" +  
                  "from all selected entities, groups and/or components." ) ; 
    return ; 
  end ; 
  Sketchup.active_model.start_operation("Delete All Materials") ; 
  x = RemMats.new ; 
  x.remove ; 
  Sketchup.active_model.commit_operation ; 

end 





 


 

def tooler_b
pages = File.join(File.dirname(__FILE__), "4dHans_ToolsInDialog/Home.html")
dlg = UI::WebDialog.new("Tools In Dialog Pro", true, 
   "ToolsInDialog", 739, 641, 150, 150, true); 
dlg.set_file (pages) 

twlg = UI::WebDialog.new("Web Browsing", true,"", 600, 600, 100, 100, true);


def create_dialog

etb = UI::WebDialog.new("Engineering ToolBox", true, "", 1000, 800, 150, 150, true);
	etb.set_url "http://sketchup.engineeringtoolbox.com/"
	etb.show
	etb.add_action_callback("insert") {|d,p|
		eval(p)
	}
end

def groupin
mymodel = Sketchup.active_model
myselection = mymodel.selection
myentities = mymodel.entities
myentities.add_group (myselection)
end

def compin
Sketchup.active_model.start_operation ("Comper")
mymodel = Sketchup.active_model
myselection = mymodel.selection
myentities = mymodel.entities
comp = myentities.add_group (myselection)
comp.to_component
Sketchup.active_model.commit_operation
end

def toolbar_explode
  Sketchup.active_model.start_operation "ungroup"
  model = Sketchup.active_model
  entities = model.entities
  selection = model.selection
  selection.each do |s|
    if s.respond_to? "explode"
      ents = s.explode
      ents = ents.select {|e| e.is_a? Sketchup::Drawingelement}
      selection.add ents
    end
  end
  Sketchup.active_model.commit_operation
end

def dialog_game
model = Sketchup.active_model
entities = model.entities
selection = model.selection

h = {}
k = []
ObjectSpace.each_object {|object|
  klass = object.class.to_s
  if klass == "Class"
    p object
    #h[klass] = object
    k << object.inspect
  end
}

puts k.sort.join("
")
end




def nosel
mnod = Sketchup.active_model
snel = mnod.selection
snel.clear
end

def toggleExtensions
  @t = Time.now
  opts = Sketchup.active_model.rendering_options
  len = opts["LineExtension"]
  state = opts["ExtendLines"]
  if @l
    if @t - @l < 0.3
      opts["ExtendLines"] = true
      ret = inputbox ["New Length:"], [len], "Change Extension Length" 
      return unless ret
      opts["LineExtension"] = ret[0]
      return
    end
  end
  opts["ExtendLines"] = ! state
  @l = @t
end

def toggleEndPoints
  @t = Time.now
  opts = Sketchup.active_model.rendering_options
  len = opts["LineEndWidth"]
  state = opts["DrawLineEnds"]
  if @l
    if @t - @l < 0.3
      opts["DrawLineEnds"] = true
      ret = inputbox ["New Width:"], [len], "Change Line End Width" 
      return unless ret
      opts["LineEndWidth"] = ret[0]
      return
    end
  end
  opts["DrawLineEnds"] = ! state
  @l = @t
end

def toggleDepthQue
  @t = Time.now
  opts = Sketchup.active_model.rendering_options
  len = opts["DepthQueWidth"]
  state = opts["DrawDepthQue"]
  if @l
    if @t - @l < 0.3
      opts["DrawDepthQue"] = true
      ret = inputbox ["New Width:"], [len], "Change Depth Cue Width" 
      return unless ret
      opts["DepthQueWidth"] = ret[0]
      return
    end
  end
  opts["DrawDepthQue"] = ! state
  @l = @t
end

def toggleProfiles
  @t = Time.now
  opts = Sketchup.active_model.rendering_options
  len = opts["SilhouetteWidth"]
  state = opts["DrawSilhouettes"]
  if @l
    if @t - @l < 0.3
      opts["DrawSilhouettes"] = true
      ret = inputbox ["New width:"], [len], "Change Profile Width" 
      return unless ret
      opts["SilhouetteWidth"] = ret[0]
      return
    end
  end
  opts["DrawSilhouettes"] = ! state
  @l = @t
end
dlg.add_action_callback("Torus") {|d, p|RP::Torus.dialog}
dlg.add_action_callback("Engineer") {|d, p|create_dialog}
dlg.add_action_callback("Image") {|d, p|Sketchup.send_action 21542}
dlg.add_action_callback("Comp") {|d, p|Sketchup.send_action 21060}
dlg.add_action_callback("Group") {|d, p|groupin}
dlg.add_action_callback("Ents") {|d, p|Sketchup.send_action 21488}
dlg.add_action_callback("Explode") {|d, p|toolbar_explode}
dlg.add_action_callback("Component") {|d, p|Sketchup.send_action 21083}
dlg.add_action_callback("Gcomp") {|d, p|compin}
dlg.add_action_callback("Tape") {|d, p|Sketchup.send_action "selectMeasureTool:"}
dlg.add_action_callback("Perspect") {|d, p|Sketchup.send_action "viewPerspective:"}
dlg.add_action_callback("Layer") {|d, p|Sketchup.send_action 21354}
dlg.add_action_callback("Shadow") {|d, p|Sketchup.send_action 10533}
dlg.add_action_callback("Move") {|d, p|Sketchup.send_action "selectMoveTool:"}
dlg.add_action_callback("Rotate") {|d, p|Sketchup.send_action "selectRotateTool:"}
dlg.add_action_callback("Hide") {|d, p|Sketchup.send_action "editHide:"}
dlg.add_action_callback("Hiderest") {|d, p|Sketchup.active_model.rendering_options["InactiveHidden"] = !Sketchup.active_model.rendering_options["InactiveHidden"]}
dlg.add_action_callback("Hidesim") {|d, p|Sketchup.active_model.rendering_options["InstanceHidden"] = !Sketchup.active_model.rendering_options["InstanceHidden"]}
dlg.add_action_callback("Unhide") {|d, p|Sketchup.send_action "editUnhide:"}
dlg.add_action_callback("Select") {|d, p|Sketchup.send_action "selectSelectionTool:"}
dlg.add_action_callback("Nosel") {|d, p|nosel}
dlg.add_action_callback("Axis") {|d, p|Sketchup.send_action "selectAxisTool:"}
dlg.add_action_callback("Default") {|d, p|remove_Materials_Smustard}
dlg.add_action_callback("Scene") {|d, p|Sketchup.send_action 21080}
dlg.add_action_callback("Soft") {|d, p|Sketchup.send_action 21490}
dlg.add_action_callback("Outliner") {|d, p|Sketchup.send_action 21513}
dlg.add_action_callback("Dimension") {|d, p|Sketchup.send_action "selectDimensionTool:"}
dlg.add_action_callback("Hidden") {|d, p|Sketchup.send_action "viewShowHidden:"}
dlg.add_action_callback("Pushpull") {|d, p|Sketchup.send_action "selectPushPullTool:"}
dlg.add_action_callback("Followme") {|d, p|Sketchup.send_action "selectExtrudeTool:"}
dlg.add_action_callback("Flickr") {|d, p|dialog_game}
dlg.add_action_callback("Undo") {|d, p|Sketchup.send_action "editUndo:"}
dlg.add_action_callback("Redo") {|d, p|Sketchup.send_action "editRedo:"}
dlg.add_action_callback("Cut") {|d, p|Sketchup.send_action "cut:"}
dlg.add_action_callback("Copy") {|d, p|Sketchup.send_action "copy:"}
dlg.add_action_callback("Paste") {|d, p|Sketchup.send_action "paste:"}
dlg.add_action_callback("Info") {|d, p|Sketchup.send_action 21170}
dlg.add_action_callback("New") {|d, p|Sketchup.send_action 57600}
dlg.add_action_callback("Open") {|d, p|Sketchup.send_action 57601}
dlg.add_action_callback("Save") {|d, p|Sketchup.send_action 57603}
dlg.add_action_callback("Erase") {|d, p|Sketchup.send_action "selectEraseTool:"}
dlg.add_action_callback("Line") {|d, p|Sketchup.send_action "selectLineTool:"}
dlg.add_action_callback("Freehand") {|d, p|Sketchup.send_action "selectFreehandTool:"}
dlg.add_action_callback("Arc") {|d, p|Sketchup.send_action "selectArcTool:"}
dlg.add_action_callback("Rectangle") {|d, p|Sketchup.send_action "selectRectangleTool:"}
dlg.add_action_callback("Circle") {|d, p|Sketchup.send_action "selectCircleTool:"}
dlg.add_action_callback("Polygon") {|d, p|Sketchup.send_action "selectPolygonTool:"}
dlg.add_action_callback("Makeface") {|d, p|makeFaces14}
dlg.add_action_callback("Purge") {|d, p|PurgeAll.do}
dlg.add_action_callback("Delete") {|d, p|Sketchup.send_action "editDelete:"}
dlg.add_action_callback("Size") {|d, p|Sketchup.send_action 10551}
dlg.add_action_callback("Colayer") {|d, p|Sketchup.active_model.rendering_options["DisplayColorByLayer"] = !Sketchup.active_model.rendering_options["DisplayColorByLayer"]}
dlg.add_action_callback("Paint") {|d, p|Sketchup.send_action "selectPaintTool:"}
dlg.add_action_callback("Weld") {|d, p|join_edges}
dlg.add_action_callback("Fog") {|d, p|Sketchup.send_action 21406}
dlg.add_action_callback("Compedge") {|d, p|Copedges.delete_coplanar_edges_loose}
dlg.add_action_callback("Frontface") {|d, p|Sketchup.active_model.select_tool FrontFaceTool.new}
dlg.add_action_callback("Testing") {|d, p|twlg.set_file File.join(File.dirname(__FILE__), "4dHans_ToolsInDialog/web1.html")
twlg.show}
dlg.add_action_callback("Matedge") do
  ro = Sketchup.active_model.rendering_options
  ecm = ro["EdgeColorMode"]
  if ecm != 0
    ecm = 0
    Sketchup.set_status_text "Egde Color Mode: by Material"
  else
    ecm = 1
    Sketchup.set_status_text "Egde Color Mode: Default"
  end
  ro["EdgeColorMode"] = ecm
end


dlg.add_action_callback("Poptext") {|d, p|Sketchup.send_action 21023}
dlg.add_action_callback("Section") {|d, p|Sketchup.send_action "selectSectionPlaneTool:"}
dlg.add_action_callback("Field") {|d, p|Sketchup.send_action "selectFieldOfViewTool:"}
dlg.add_action_callback("Text") {|d, p|Sketchup.send_action "selectTextTool:"}
dlg.add_action_callback("Look") {|d, p|Sketchup.send_action "selectTurnTool:"}
dlg.add_action_callback("Pan") {|d, p|Sketchup.send_action "selectDollyTool:"}

dlg.add_action_callback("Hiden") {|d, p|Sketchup.active_model.rendering_options["RenderMode"] = 1}
dlg.add_action_callback("Mono") {|d, p|Sketchup.active_model.rendering_options["RenderMode"] = 5}
dlg.add_action_callback("Shad") {|d, p|Sketchup.active_model.rendering_options["RenderMode"] = 2
Sketchup.active_model.rendering_options["Texture"] = false}
dlg.add_action_callback("Teks") {|d, p|Sketchup.active_model.rendering_options["RenderMode"] = 2
Sketchup.active_model.rendering_options["Texture"] = true}
dlg.add_action_callback("Wire") {|d, p|Sketchup.active_model.rendering_options["RenderMode"] = 0}
dlg.add_action_callback("Cent") {|d, p|centerSelection}
dlg.add_action_callback("Zoom") {|d, p|
  if Sketchup.active_model.selection.length <= 0
    Sketchup.send_action "viewZoomExtents:" 
  else
    Sketchup.send_action "selectionZoomExt:"
  end}
#dlg.add_action_callback("Covex") {|d, p|UI.beep}
dlg.add_action_callback("Store") {|d, p|JF::sel_store }
dlg.add_action_callback("Recall") {|d, p|JF::sel_recall }
dlg.add_action_callback("Add") {|d, p|JF::sel_add }
dlg.add_action_callback("Subtract") {|d, p|JF::sel_sub }
dlg.add_action_callback("Close") {|d, p|dlg.close}
dlg.add_action_callback("Zopsicle") {|d, p|Sketchup.send_action "selectSelectionTool:"}
dlg.add_action_callback("Fairy") {|d, p|Sketchup.send_action "selectTurnTool:"}
#dlg.add_action_callback("Joint") {|d, p| JointPushPull.execute 'J'}
#dlg.add_action_callback("Vector") {|d, p| JointPushPull.execute 'V'}
#dlg.add_action_callback("Normal") {|d, p| JointPushPull.execute 'N'}
#dlg.add_action_callback("Ju") {|d, p| JointPushPull.undo}
#dlg.add_action_callback("Jr") {|d, p| JointPushPull.redo}
dlg.add_action_callback("Offset") {|d, p|Sketchup.send_action "selectOffsetTool:"}
dlg.add_action_callback("Ruby") {|d, p|Sketchup.send_action "showRubyPanel:"}
dlg.add_action_callback("Orbit") {|d, p|Sketchup.send_action "selectOrbitTool:"}
dlg.add_action_callback("Zoomin") {|d, p|Sketchup.send_action "selectZoomTool:"}
dlg.add_action_callback("Scale") {|d, p|Sketchup.send_action "selectScaleTool:"}
dlg.add_action_callback("Depthq") {|d, p|toggleDepthQue}
dlg.add_action_callback("Endpt") {|d, p|toggleEndPoints}
dlg.add_action_callback("Extens") {|d, p|toggleExtensions}
dlg.add_action_callback("Profiles") {|d, p|toggleProfiles}
dlg.add_action_callback("Dispedge") {
  if Sketchup.active_model.rendering_options["EdgeDisplayMode"] == 0
    Sketchup.active_model.rendering_options["EdgeDisplayMode"] = 1
  else
    Sketchup.active_model.rendering_options["EdgeDisplayMode"] = 0
  end
}


dlg.add_action_callback("Jitter") {|d, p|
Sketchup.active_model.rendering_options["JitterEdges"] = !Sketchup.active_model.rendering_options["JitterEdges"]}
dlg.add_action_callback("Xray") {|d, p|Sketchup.active_model.rendering_options["ModelTransparency"] = ! Sketchup.active_model.rendering_options["ModelTransparency"]}
dlg.add_action_callback("Selector") {|d, p|Selector.start}
dlg.add_action_callback("Super") {|d, p|RP::Superellipsoid.dialog}
dlg.add_action_callback("Rotrec") {|d, p|Sketchup.active_model.select_tool RectangleTool.new}
dlg.add_action_callback("Align") {|d, p|Align.tool}
dlg.add_action_callback("Protractor") {|d, p|Sketchup.send_action "selectProtractorTool:"}
#dlg.add_action_callback("Point") {|d, p|PointTool.tool}
dlg.add_action_callback("Attribmg") {|d, p|AttribManagerProduct.new;}
dlg.show
end
toolbar = UI::Toolbar.new "4dHans_Tools" 
aaa = UI::Command.new("aaa") {tooler_b} 
aaa.small_icon = "4dHans_ToolsInDialog/images/manager_tool.jpg" 
aaa.large_icon = "4dHans_ToolsInDialog/images/manager_tool.jpg" 
aaa.tooltip = "Dialog Tools" 
aaa.status_bar_text = "Testing the toolbars class" 
toolbar.add_item (aaa)
toolbar.show
tooler_b